import java.util.Locale;
import java.util.Formatter;
import java.util.Formattable;

public class MyObject implements Formattable {
  String name;
  public MyObject(String name) {
    this.name = name;
  }
  public void formatTo(
         Formatter fmt,
         int f,
         Integer width,
         Integer precision) {

    StringBuilder sb = new StringBuilder();
    if (precision == null) {
      // no max width
      sb.append(name);
    } else if (name.length() < precision) {
      sb.append(name);
    } else {
      sb.append(name.substring(0, precision - 1)).append('*');
    }

    // apply width and justification
    if ((width != null) && (sb.length() < width)) {
      for (int i = 0, n=sb.length(); i < width - n; i++) {
        if ((f & Formattable.LEFT_JUSTIFY) == Formattable.LEFT_JUSTIFY) {
          sb.append(' ');
        } else {
          sb.insert(0, ' ');
        }
      }
    }
    fmt.format(sb.toString());
  }

  public static void main(String args[]) {
   MyObject my1 = new MyObject("John");
   MyObject my2 = new MyObject("Really Long Name");
   // First / Using toString()
   System.out.println("First Object : " + my1);
   // Second / Using Formatter
   System.out.format("First Object : '%s'\n", my1);
   // Second / Using Formatter
   System.out.format("Second Object: '%s'\n", my2);
   // Second / Using Formatter with width
   System.out.format("Second Object: '%10.5s'\n", my2);
   // Second / Using Formatter with width and left justification
   System.out.format("Second Object: '%-10.5s'\n", my2);
  }
}
